#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    xzcat strace-4.7.tar.xz | tar xf -
#    tar xjf strace-4.7.tar.bz2
    cd strace-4.7
    ./configure --prefix=/usr --sysconfdir=/etc
    if [ "`uname -m`" = 'sparc' ]; then
	# Maybe should do this for all arches regardless!
	sed -i 's/^#undef HAVE_LINUX_PTRACE_H$/#define HAVE_LINUX_PTRACE_H 1/' \
		config.h
    fi
    make
    strip -R .note -R .comment strace
    mkdir -p ../strace/bin
    cp strace ../strace/bin/
    cd ..
    rm -rf strace-4.7
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
